#ifdef __cplusplus
    extern "C" {
#endif

/*     */
typedef void (*FuncDtor)(void*);

/*       */
struct DtorNode
{
    void* _this;
    FuncDtor dtor;
    struct DtorNode* next;
};

/*      */
static struct DtorNode* dtorHead = 0;

/*     */
void _libraryAddDtor(struct DtorNode* ptr)
{
    ptr->next = dtorHead;
    dtorHead = ptr;
}

/*      */
void _callDtors()
{
    while(dtorHead)
    {
        struct DtorNode* temp = dtorHead;
        dtorHead = temp->next;
        temp->dtor(temp->_this);
    }
}

#ifdef __cplusplus
    }
#endif
