//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// data.asm -                                                               //
//                                                                          //
// Arrays definitions                                                       //
//                                                                          //
// Copyright (c) 1999 RC Module Inc.                                        //
//                                                                          //
// $Revision:: 1     $      $Date:: 3/10/06 4:35p    $                      //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////


nobits ".bss"   // data from one bus
    global _input  :long[16];      // net inputs (12 values)
    global _hidden :long[1024];    // first layer outputs (1024 values)
    global _output :long[12];      // second layer outputs (12 values)
end ".bss";


nobits ".bss1"   // data from other bus
    global _weights1   :long[ 12 / 4 * 1024 ];  // weights for the first layer
    global _weights2   :long[ 1024 / 4 * 12 ];  // weights for the second layer
end ".bss1";
